#!/system/bin/sh
# portions from franciscofranco, ak, boype & osm0sis + Franco's Dev Team

$bb mount -o rw,remount /system;
# custom busybox installation shortcut
bb=/sbin/bb/busybox;

# ensure SuperSU daemonsu/Superuser su_daemon service is running
if [ -e /system/xbin/daemonsu ]; then
  /system/xbin/daemonsu --auto-daemon&
elif [ ! -e /init.superuser.rc ]; then
  /system/xbin/su --daemon&
fi;

# create and set permissions for /system/etc/init.d if it doesn't already exist
if [ ! -e /system/etc/init.d ]; then
  mkdir /system/etc/init.d;
  chown -R root.root /system/etc/init.d;
  chmod -R 755 /system/etc/init.d;
fi;

# disable sysctl.conf to prevent ROM interference with tunables
$bb [ -e /system/etc/sysctl.conf ] && $bb mv -f /system/etc/sysctl.conf /system/etc/sysctl.conf.bak;

# disable the PowerHAL since there is now a kernel-side imput boost implemented
$bb [ -e /system/lib/hw/power.tuna.so ] && $bb rm -f /system/lib/hw/power.tuna.so;

# set input boost duration and frequency 
echo 80 > /sys/module/cpu_boost/parameters/boost_ms;
echo 120000 > /sys/module/cpu_boost/parameters/input_boost_freq;
echo 250 > /sys/module/cpu_boost/parameters/input_boost_ms;

# disable pvr module if there is one 
$bb [ -e /system/lib/modules/pvrsrvkm_sgx540_120.ko ] && $bb rm -f /system/lib/modules/pvrsrvkm_sgx540_120.ko;

# backup and replace Host AP Daemon for working Wi-Fi tether on 3.4 kernel Wi-Fi drivers

$bb cp -f /sbin/hostapd /system/bin/;
chown root.shell /system/bin/hostapd;
chmod 755 /system/bin/hostapd;

# increase sched timings
echo 15000000 > /proc/sys/kernel/sched_latency_ns;
echo 2000000 > /proc/sys/kernel/sched_min_granularity_ns;
echo 2500000 > /proc/sys/kernel/sched_wakeup_granularity_ns;
echo 962500 > /proc/sys/kernel/sched_rt_runtime_us;

# double the default minfree kb
echo 2884 > /proc/sys/vm/min_free_kbytes;

# improve zram compression performance
echo "lz4" > /sys/block/zram0/comp_algorithm;
echo 2 > /sys/block/zram0/max_comp_streams;

# increase swappiness and enable zram 
echo 70 > /proc/sys/vm/swappiness;
echo $((64 * 1024 * 1024)) > /sys/block/zram0/disksize;
  mkswap /dev/block/zram0;
  swapon /dev/block/zram0;

# Tweak Zswap
echo 40 > /sys/module/zswap/parameters/max_pool_percent;

# more rational defaults UKSM 
echo 1 > /sys/kernel/mm/uksm/run;
echo 150 > /sys/kernel/mm/uksm/sleep_millisecs;
echo 40 > /sys/kernel/mm/uksm/max_cpu_percentage;
echo "quiet" > /sys/kernel/mm/uksm/cpu_governor;

# general queue tweaks
for i in /sys/block/*/queue; do
  echo 512 > $i/nr_requests;
  echo 512 > $i/read_ahead_kb;
  echo 2 > $i/rq_affinity;
  echo 0 > $i/nomerges;
  echo 0 > $i/add_random;
  echo 0 > $i/rotational;
done;

$bb mount -o ro,remount /system;

# CPU  
echo 1200000 > /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq;
echo 250000 > /sys/devices/system/cpu/cpu0/cpufreq/scaling_min_freq;
echo 920000 > /sys/devices/system/cpu/cpu0/cpufreq/screen_off_max_freq;
echo 550000 > /sys/devices/system/cpu/cpu0/cpufreq/screen_on_min_freq;

# GPU 
echo "onoff" > /sys/devices/platform/omap/pvrsrvkm.0/sgxfreq/governor;
echo 384000000 > /sys/devices/platform/omap/pvrsrvkm.0/sgxfreq/frequency_limit;


# set up Synapse support
/sbin/uci&
[ -d /sdcard/Synapse/saved_profiles ] && $bb cp -f /res/synapse/profiles/* /sdcard/Synapse/saved_profiles/;
done&


